// Задача "Распил"
// 10-ая Всероссийская командная олимпиада школьников по программированию
// Автор задачи:  Елена Андреева
// Автор решения: Антон Банных, argentony@gmail.com

//Не работает при m + k - n = 4, m <= 4
import java.io.*;
import java.util.*;
import java.math.*;

public class cut_ab_wa implements Runnable {

	final int MAX = 200;
	final int MIN = 3;

	final String YES = "Yes";
	final String NO = "No";

	private void solve() throws IOException {
		int n = in.nextInt();
		myAssert(MIN <= n && n <= MAX);
		int m = in.nextInt();
		myAssert(MIN <= m && m <= MAX);
		int k = in.nextInt();
		myAssert(MIN <= k && k <= MAX);
		if (m > k) {
			int t = m;
			m = k;
			k = t;
		}
		
		if (n == 5 && m == 3 && k == 6) {
			out.println(YES);
			out.println("0 0");
			out.println("1 0");
			out.println("1 -1");
			out.println("2 1");
			out.println("1 -2");
			out.println("1 2");
			return;
		}
		
		if (n == 6 && m == 4 && k == 6) {
			out.println(YES);
			out.println("0 0");
			out.println("1 0");
			out.println("2 1");
			out.println("2 -1");
			out.println("3 -1");
			out.println("3 3");
			out.println("1 2");
			return;
		}
		
		if (n == 5 && m == 4 && k >= 4) {
			out.println(NO);
			return;
		}
		
		if (m + k < n || m + k > n + 4) {
			out.println(NO);
			return;
		}
		int diff = m + k - n;
		int min = 6 - diff;
		if (diff > 2) {
			min = 5;
		}
		if (n < min) {
			out.println(NO);
		} else {
			out.println(YES);
			out.println("0 0");
			int cnt = 2;
			int sub = 2;
			if (diff == 4) {
				sub = 4;
			}
			for (int i = 0; i < m - sub; ++i) {
				out.println(((i / 2) + 1) + " " + (-4 - (i % 2)));
				++cnt;
			}
			if (diff <= 1) {
				out.println("999 0");
				++cnt;
			}
			if (diff >= 3) {
				out.println("999 1");
				++cnt;
			}
			out.println("1000 0");
			sub = 2;
			if (diff >= 3) {
				sub = 4;
			}
			for (int i = 0; i < k - sub; ++i) {
				out.println((999 - (i / 2)) + " " + (4 + (i % 2)));
			}
			if (diff == 0) {
				out.println("1 0");
			}
			if (diff == 4) {
				out.println("1 -1");
			}
			out.println(1 + " " + cnt);
		}

	}

	void myAssert(boolean e) {
		if (!e) {
			throw new Error();
		}
	}

	final String FILE_NAME = "cut";

	SimpleScanner in;
	PrintWriter out;

	@Override
	public void run() {
		try {
			in = new SimpleScanner(new FileReader(FILE_NAME + ".in"));
			out = new PrintWriter(FILE_NAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	public static void main(String[] args) {
		new Thread(new cut_ab_wa()).start();
	}

	class SimpleScanner extends BufferedReader {

		private StringTokenizer st;
		private boolean eof;

		public SimpleScanner(Reader a) {
			super(a);
		}

		String next() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(readLine());
				} catch (Exception e) {
					eof = true;
					return "";
				}
			}
			return st.nextToken();
		}

		boolean seekEof() {
			String s = next();
			if ("".equals(s) && eof)
				return true;
			st = new StringTokenizer(s + " " + st.toString());
			return false;
		}

		private String cnv(String s) {
			if (s.length() == 0)
				return "0";
			return s;
		}

		int nextInt() {
			return Integer.parseInt(cnv(next()));
		}

		double nextDouble() {
			return Double.parseDouble(cnv(next()));
		}

		long nextLong() {
			return Long.parseLong(cnv(next()));
		}
	}
}